#include <Propeller2.h>
#include <stdio.h>
#include <string.h>
#include "simpletools.h"
#include <smartpins.h>

#include <stdint.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>

#define bufs 19200
#define ROW 5


#define PDATAC 16 // PB8
#define PDATAM 17 // conn9 28 PF9
#define PDATAY 18 // conn9 30 PG1
#define ADATA 19 // PA6

#define LOAD 3
#define CLK 6
#define rotate 10
#define led 9
#define led2 10 // BLUE LED

static long stack[32];
static long stack2[32];
static long stack3[20000];
static long stack4[32];
static long stack5[3000];

bool AData[40];
bool Pdatac[10][40];
bool Pdatam[10][40];
bool Pdatay[10][40];

bool temp_Pdata[120];

int loop_count = 0;
unsigned char hex_t[rotate][40];

int cogid1;
int cogid2;
int cogid3;
int cogid4;
int cogid5;

int data_count;
int motor_dir = 0;

enum {
//	_xinfreq = 20_000_000,
	_xtlfreq = 20_000_000,
	_clkfreq = 256_000_000,
	DOWNLOAD_BAUD = 230_400,
	DEBUG_BAUD = DOWNLOAD_BAUD,

	PINS = 20|7<<6,
	GROUP = 2,
	CLK_PIN = 6,

	TX_REGD = 1,
	CLK_REGD = 0,
	CPOL = 1,
	CPHA = 0,
	//CLK_DIV = 2,
	HEAPSIZE = 80000,
	CLK_DIV = 16,
	M_NCO = 0x8000_0000UL / CLK_DIV + (0x8000_0000UL % CLK_DIV > 0UL ? 1UL : 0UL),    // round up
	//M_LEADIN = X_IMM_32X1_1DAC1 | 7 + CLK_DIV + CLK_REGD - TX_REGD - (1 ^ CPHA) * (CLK_DIV>>1),
	M_LEADIN = X_IMM_32X1_1DAC1 | 7 + CLK_DIV + CLK_REGD - TX_REGD - (1 ^ CPHA) * (CLK_DIV>>1),

};




static void  pinout8clk_dma( unsigned pgroup, unsigned clkpin)
{
printf("DMA cog started\n");
while(true)
{
        while(_pollatn()==0);
        //printf("Received attenuation dma\n\n");
        int len = 40;
        uint32_t  m_tx = X_RFBYTE_8P_1DAC8 | pgroup<<20 | X_PINS_ON | len;  // byte wide transfers from hubRAM, via the FIFO
	uint32_t  datp = pgroup<<3 | 7<<6;
	for(int index = 0;index<rotate;index++)
	{
		unsigned char* haddr = &hex_t[index][0];
		int val;
	__asm volatile {  // no optimising and enforces Fcache use - Needed to free up the FIFO
		rdfast	#0, haddr    // setup the FIFO to read from hubRAM, non-blocking
		setxfrq	m_nco1    // set sysclock/1 for lead-in timing
		//drvl	datp    // active data pins for tx data
		xinit	leadin, #0    // lead-in timing, at sysclock/1
		setq	m_nco2    // streamer transfer rate
		xcont	m_tx, #0    // setup buffered command for tx data
		//dirh	clkpin    // start smartpin internally cycling, at SPI clock rate
		//wypin	len, clkpin    // produce clocks, starting on second internal cycle

		drvl	datp    // active data pins for tx data// declare datp as output and make value 0
		NOP
		dirh	clkpin    // start smartpin internally cycling, at SPI clock rate , set clkpin as output
		//NOP
		wypin	len, clkpin    // produce clocks, starting on second internal cycle

		// twiddle thumbs while DMA happens ...

		waitxfi   // wait for transfer to complete before returning back to hubexec, hubexec uses the FIFO
		
		dirl	clkpin    // reset smartpin
	_ret_	dirl	datp    // tristate the data bus upon completion

leadin		long	M_LEADIN
m_nco2		long	M_NCO
m_nco1		long	0x8000_0000
	}
	}
	_pinw(PDATAC, 0);
        _pinw(PDATAM, 0);
        _pinw(PDATAY, 0);
        _pinw(ADATA, 0);
        memset(hex_t,0x00,sizeof(hex_t));
}

}


void fillHexdataasm(int index)
{
  int i = 0;
  memset(&hex_t[index],0x00,40);
  // printf("index = %d\n", index);
  
  for (i = 0; i < 40; i++) {
    //hex_t[index][i] = (Pdatac[index][i])|(Pdatam[index][i] << 1)|(Pdatay[index][i] << 2)|(AData[i]<<3);
    (i>17)?(hex_t[index][i] = (Pdatac[index][i])|(Pdatam[index][i] << 1)|(Pdatay[index][i] << 2)|(AData[i]<<3))
    	  :(hex_t[index][i] = (Pdatac[index][i])|(Pdatam[index][i] << 1)|(Pdatay[index][i] << 2));    
   // printf("hex_t[%d][%d] => C = %d M = %d Y = %d AD = %d ==> %X\n ",index,i,Pdatac[index][i],Pdatam[index][i],Pdatay[index][i],AData[i],hex_t[index][i]); 
   /*if((index== 1) && (i>=35 && i<=39))
    	printf("%d: hex= %d Adata: =%d \n\n",i,hex_t[index][i],AData[i]);*/

    }
    
}

int cnt = 1;
int n = 0;
//int Print_Data(char * buf, int ret) {
int Print_Data() {
while(data_count>0)
 {
   
  printf("started new data print: %d\n",data_count);
  memset(temp_buf_t,0,bufs);
  memcpy(temp_buf_t,buf_t,data_count);
  int ret = data_count;
  int temp_px = 0;
  int Pfd = 1;
  int Prev = 39;

  data_count = 0;
  //sending attenuation to filldata()
  _cogatn((1<<cogid3));

  high(41); // Level shifter
  static int Ax = 0;
  int px = 0;
  int index = 0;
  for (int j=0; j <= ret; j += 3) {
   //   high(41);
    // Logic to fill data for 10/20 cycles
    _pinf( LOAD );
  
    int percent_c = (int)(temp_buf_t[j]);
    int percent_m = (int)(temp_buf_t[j + 1]);
    int percent_y = (int)(temp_buf_t[j + 2]);
	if (temp_px < 2)
	{
	       index =  Prev *3;
		temp_Pdata[index] = percent_c ? 1: 0;
		temp_Pdata[index + 1] = percent_m? 1: 0;
		temp_Pdata[index + 2] = percent_y ? 1: 0;
		//printf("Filling Prev %d\n",Prev);
		Prev--;
		temp_px++;
		if (Prev == 19)
		{
			Prev = 39;
		}
	}
	else
	{
		index =  Pfd *3;
		temp_Pdata[index] = percent_c ? 1: 0;
		temp_Pdata[index + 1] = percent_m ? 1:0;
		temp_Pdata[index + 2] = percent_y ? 1:0;
		//printf("Filling Pfd %d\n",Pfd);
		Pfd--;
		temp_px++;
		if (temp_px == 4)
		{
			temp_px = 0;
			Pfd += 4;
		}

		if (Pfd == 21)
		{
			Pfd = 1;
		}
	}
			        
			        
				
	px++;
	_pinw(led2,1);
	_waitx(10);
	_pinw(led2,0);
	
      if (px == 40) {
        Ax++;
        px = 0;
      }

      if (Ax  == 10) {

          Ax = 0;
      	  px = 0;
	bool flag_ad = 0;
        // 10 Cycles fill data finished
        for (int d = 0; d < rotate; d++) {
          for(int r = 0;r<40;r++)
          {
                  //Filling ADATA bits from 31 to 39
                 if(r>30)
                 {
          		AData[r] = flag_ad;
          		flag_ad = !flag_ad;
          	}
          		
          }
          
          fillHexdataasm(d);
	}
	 _cogatn((1<<cogid1)); //send attenuation to DMA function
      }

    }
    }
  printf("\n\nFinished processing of %d\n\n",data_count);
  return 0;
}
void Filldata()
{
        while(true)
        {
        	bool sample_data = true;
		for(int i = 0;i<bufs;i +=3)
		{
			buf_t[i] = sample_data;
			buf_t[i+1] = sample_data;
			buf_t[i+2] = sample_data;
			
			
			sample_data = !sample_data;
			data_count += 3;
		}
		_cogatn(1<<0);
		while(_pollatn() == 0);
		loop_count++;
		if(loop_count >=50)
		{	
			data_count = 0;
			break;
		}
		
	}        
}
void init()
{
  set_directions(13, 0, 0b1111111111111);
  set_outputs(13, 0, 0b0000000000000);
  set_directions(19, 16,0b0000);
  set_outputs(19, 16, 0b0000);
  low(41);
  high(LOAD);
  //_pinw(LOAD,0);
  //_pinw(LOAD,1);
  int x = 20;
  int y = 10;
  
  
  //
	_pinf( GROUP<<3 | 7<<6 );
	_wrpin( GROUP<<3 | 7<<6, TX_REGD ? P_SYNC_IO : 0 );  // at sysclock/1, data pins should be registered to minimise relative skew

	_pinf( CLK_PIN );
	_pinf( LOAD );
	_wrpin( CLK_PIN, P_PULSE | P_OE | (CLK_REGD ? P_SYNC_IO : 0) | (CPOL ? P_INVERT_OUTPUT : 0) );    // clock pins
	_wxpin( CLK_PIN, CLK_DIV | (CLK_DIV>>1 + (CPOL & CLK_DIV))<<16 );    // set period and duty

  //     
        set_direction(27, 1);
     high(27);// 3.3v for encoder and TSR from pin 27
    set_output(29,0);
  set_direction(29, 0);

	set_output(led, 0);
	set_direction(led, 0);
	set_output(led2, 0);
	set_direction(led2, 0);


  set_output(28,0);
  set_direction(28, 1); 
}
static int cnn3 = 0;


unsigned char buf_t[19200] = {0};
unsigned char temp_buf_t[19200] = {0};
int main() {
  int count = 0;
  printf("Main start!\n");
  init();
  _pinf( LOAD );
  int ret = 0;
  int x = 0;
  low(41);
  printf( "   clkfreq = %d   clkmode = 0x%x m_nco = 0x%x M_LEADIN = 0x%x\n", _clockfreq(), _clockmode(), M_NCO, M_LEADIN );
  cogid1 = __builtin_cogstart(pinout8clk_dma(GROUP, CLK_PIN), stack);
  //Cog for Read SD card data
  cogid3 = __builtin_cogstart(Filldata(), stack3);   
  //cogid5 = __builtin_cogstart(get_position(), stack5); 
  printf("Cog started with cogid: %d\n",cogid4);
  
  count = 0;
  
	while(true)
	
	{
	        while(_pollatn()==0);		
		Print_Data();
		//Print_Data(buf_p, ret);
		_waitus(10);
		printf("Finished print_data function\n\n");
		if(data_count <= 0)
		{
		        _cogstop(cogid1);
		      	_cogstop(cogid3);
			//_cogstop(cogid5);
		        _pinclear(CLK_PIN);
	    	       	set_direction(CLK_PIN, 1);
	    	       	_pinw(CLK_PIN,1);
			break;
		}
		
	}
  	_waitms(2000);
  return 0;
}
